//
//  PaddlesAppDelegate.m
//  Paddles
//
//  Created by Todd Moore - http://toddmoore.com/
//

#import "PaddlesAppDelegate.h"

#import "PaddlesViewController.h"
#import "TitleViewController.h"

@implementation PaddlesAppDelegate

@synthesize window = _window;
@synthesize viewController = _viewController;
@synthesize gameController;

- (void)dealloc
{
    [_window release];
    [_viewController release];
    [super dealloc];
}

- (void)showTitle
{
    // dismiss the game controller
    if (self.gameController)
    {
        [self.viewController dismissModalViewControllerAnimated:
                                                            NO];
        self.gameController = nil;
    }
}
- (void)playGame: (int) computer
{
    // present the game over the title
    if (self.gameController == nil)
    {
        self.gameController = [[[PaddlesViewController alloc] 
                     initWithNibName:@"PaddlesViewController" 
                                    bundle:nil] autorelease];
        self.gameController.computer = computer;
        
        [self.viewController presentModalViewController: 
                        self.gameController animated:NO];
    }
}

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    self.window = [[[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]] autorelease];
    // Override point for customization after application launch.
    self.viewController = [[[TitleViewController alloc] initWithNibName:@"TitleViewController" bundle:nil] autorelease];
    self.window.rootViewController = self.viewController;
    [self.window makeKeyAndVisible];
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
    
    // pause the game if active
    if (self.gameController)
    {
        [self.gameController pause];
    }
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    /*
     Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
     If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
     */
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    /*
     Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
     */
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
     */
    
    // resume the game if active
    if (self.gameController)
    {
        [self.gameController resume];
    }
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    /*
     Called when the application is about to terminate.
     Save data if appropriate.
     See also applicationDidEnterBackground:.
     */
}

@end
